



//------  EEPROM 1024 du  PIC18F---------------

unsigned char EEPROM_Lect(unsigned int AdrL) // lecture a l'adresse adr
{
    EEADR =(unsigned char)(AdrL&0x00FF);
    EEADRH =(unsigned char) ((AdrL>>8)&0x0003);   //Bits 2-7 are masked off since EEPROM is only 1KB
        EECON1.EEPGD=0;     // 0= adressage EEPROM
        Delay_ms(1);
        EECON1.CFGS=0;      // 0= acces data EEPROM
        EECON1.RD=1;        // arme Lecture EEprom
        Delay_ms(20);;
        return(EEDATA);
}

void EEPROM_Ecr(unsigned int AdrE,unsigned char car) // ecrit  a l'adresse adrE
{int dr=0;
    EEADR =AdrE & 0xFF;
    EEADRH = (AdrE>>8)& 0x03;   //Bits 2-7 are masked off since EEPROM is only 1KB
        EEDATA=car;
        EECON1.EEPGD=0;
        EECON1.WREN=1;            // autorise ecriture EEPROM
        EECON1.CFGS =0;
  if(INTCON.GIE ==1)
    {
    INTCON.GIE =0 ;
    dr=1;
    }
        EECON2=0x55;
        EECON2=0xAA;
        EECON1.WR=1;
        while (PIR2.EEIF==0);
        PIR2.EEIF=0;
        EECON1.WREN=0;
        if (dr==1)INTCON.GIE =1;
}

void Save_Msg_To_EEPROM(unsigned int adrx, unsigned char * ptr1)
{
        while (*ptr1) EEPROM_Ecr(adrx++,*ptr1++);
}

void PrintOut_Eeprom_Msg(unsigned int PtrE)
{ unsigned char c;
  do
  {
  if ( PtrE >1023) break;
  c = EEPROM_Lect(PtrE);
  if ( c==0) break;
  UART1_Write(c);
  PtrE++;
  }
  while (c!=0)  ;
 Delay_ms(10);
}

void RAZ_PIC_EEPROM()
{
   int k;// blanchit EEPROM
   for(k=0;k<1023;k++)
   {
    EEPROM_Ecr(k,0x20); // ecrit " " (space) a l'adresse adrE
   }
 }

void Relit_PIC_Eeprom()
{
unsigned int i,ind,k;
char c1;
INTCON.GIE =0 ;  // inhibe globale des IT
i=(unsigned int)EEPROM_Lect(0)<< 8 ;
ind = i +(unsigned int)EEPROM_Lect(1);
k=sprintf(txt,"Lecture Eeprom PIC  Ix=%05d\t",ind);
UART1_Write_Text(txt);
k=sprintf(txt,"Nb_Watt;Temp_ext;Nb_Chauffes\r\n");
UART1_Write_Text(txt);
if (ind>1023)     return;
for (i=2;i<ind;i++)
{
   c1=EEPROM_Lect(i);
   UART1_Write(c1);
}
CRLF1();
if(buff1[0]=='L')
{
 buff1[0]=0;
 NbErr=0;
 DataReady1 =0;
 PIE1.RCIE = 1;
 i1=0;
}
 INTCON.GIE =1 ;  // autorisation globale des IT
}



