// rev 16 avr 2016
//  Nokia LCD
//  pin support LCD Nokia  1 .. 8  sur connecteur Blanc Platine  pins 1 .. 8
#define D_C LATC.B1
#define SCE LATC.B0
#define RES LATC.B2
#define SCK LATC.B3
#define SDI LATC.B4

#ifndef Byte
#define Byte
#endif


extern float F1;
extern *table;
extern *Ram_Video;

void initlcd(void);
void sendcmd(char x);
void senddata(char x);
void Erase_Line(int L);
void Nokia_Clean_Ram(void);
void Lcd_Car(int Lig,int Col, unsigned char c);
void Bargraph (int V , int ligne);
void gotoxy( char Col, char Lig);
void sendchar(char x);
void sendpack(char x);

void Nokia_Raz_Ram_Video(void)  ;
void Nokia_Print_Ram_Video(void);
void Nokia_Image_96x64(const char *image) ;
//void Nokia_Affiche_Ram_Video(void)  ;
void Nokia_Put_Pixel (char x, char y, char color) ;
//void Nokia_Bitmap_96x64 ( unsigned char * bitmap);

void NOKIA_Text(int x, int y, char size,unsigned char *caracter);
void NOKIA_Chr_8x7(char xNOKIA,char yNOKIA, char charsel) ;
void NOKIA_CText_8x7(char L,char  C, const char *txt);

void Nokia_Line (char x1, char y1, char x2, char y2, char color);

void initlcd(void)
{
RES =1;
SCE =1;
RES =0;
Delay_ms(200);
RES=1;            // come out of lcd state
sendcmd(0x21);    //Function SET: 00100_PD_V_H
sendcmd(0x90);    //VLCD=;3.06+162*0.06=4.02
sendcmd(0x05);    //; TC0=1 TC1=0
sendcmd(0x13);    //bias System 1:48 -> n=4
sendcmd(0x20);    //Function SET: 00100_PD_V_H
Delay_ms(10);
sendcmd(0x0C);
Nokia_Clean_Ram();
Delay_ms(100);
 sendcmd(0x40);  //  Y=0 0100 0yyy
  sendcmd(0x80);  //  X =0 1xxx xxxx
}

void sendcmd(char x)
{
D_C= 0;
SCE=0;
sendpack(x);
Delay_ms(1);
SCE=1; //deselect the display
return;
}

void senddata(char x)
{
D_C= 1;
   Delay_us(2);
SCE=0;
   Delay_us(2);
sendpack(x);
SCE=1; //deselect the display
}

void sendpack(char x)
{ int i;
 for(i=0;i<8;i++)
 {
   SCK=0;
   Delay_us(2);
  //   if((Cc && 0x80)==1)
  if ((x&0x80)==0x80) SDI=1; else SDI=0;
   Delay_us(2);
   SCK=1;
  x=x<<1;
     Delay_us(2);
 }
}



void Erase_Line(int L)
{
 int i,j;
 gotoxy(0,L);
 Delay_ms(10);
 i=(L-1)*96;;
 j=i+96;
 for(L=i;L<j;L++)
 {
 senddata(0x00);
 Delay_ms(1);
 }
  gotoxy(0,L);
   Delay_ms(2);
}


void Nokia_Clean_Ram(void)
{int i;
 sendcmd(0x40);  //  Y=0 0100 0yyy
  sendcmd(0x80);  //  X =0 1xxx xxxx
 Delay_ms(10);
for(i=0;i<768;i++)
{
senddata(0x00);
 Delay_ms(1);
}
}


void Lcd_Car(int Lig,int Col, unsigned char c)
 {
   gotoxy(Col,Lig);      // attention Lig varie de 1  8
   sendchar(c);
   }

void Bargraph (int V , int ligne)
{
  unsigned int i,j,m;
   F1= (float)V *96.0/1024.0;
   m=(unsigned int)F1;
  if ((ligne>0) && (ligne<9))    //   1  8
  {
    sendcmd(0x40|((ligne-1) & 0x07));
   for (i=0;i<94;i++)
   {
     sendcmd(0x80|i);
     if (i<=m)  senddata(0x3C); else  senddata(0x00);
     Delay_us(5);
   }
    sendcmd(0x40|((ligne-1) & 0x07));
  }
 }


void gotoxy( char Col, char Lig)
{ if ((Lig>0) && (Lig<9))    //   1  8
 {
  sendcmd(0x40|((Lig-1) & 0x07));  //  Y axe initialisation: 0100 0yyy
  sendcmd(0x80|((Col*6) & 0x7f));  //  X axe initialisation: 1xxx xxxx
 }
}

void sendchar(char x)
{ int a,b;
char c;
  // table de caractere de 32  127
  if((x<0x20)||(x>0x7f)) return;
  // caractere de 5 pixel de large => 32 x 5 = 160
  // offset 160 pour debut car ascii
  a=(5*x)-160;
  for(b=5;b>0;b--)    // explore chaque byte du caractere
 {
    c=table[a];
    senddata(c);  // envoi les 8 bits
    a++;
 }
 senddata(0x00);  // espace inter caractere
}

void Nokia_Raz_Ram_Video(void)
{
int ddram;
 sendcmd(0x40);  //  Y=0 0100 0yyy
  sendcmd(0x80);  //  X =0 1xxx xxxx
   for (ddram=0;ddram<768;ddram++)   Ram_Video[ddram]=0;
}


void Nokia_Print_Ram_Video(void)
{
int ddram;
   sendcmd(0x40);  //  Y=0 0100 0yyy
  sendcmd(0x80);  //  X =0 1xxx xxxx
   for (ddram=0;ddram<768;ddram++) {
     senddata(Ram_Video[ddram]);
   }
}


void Nokia_Put_Pixel (char x, char y, char color)
{
   int idx;
   idx = ((int)(y/8) * 96) + x;
   if (color)
       Ram_Video[idx] = Ram_Video[idx] | (1<< (y % 8));
   else
       Ram_Video[idx] = Ram_Video[idx] & (0xFF - (1<< (y % 8)));
}



void Nokia_Image_96x64(const char *image)
{
int i,j,x;
unsigned int k;
unsigned char masque;
unsigned char cx;
 gotoxy(0,0);
 UART1_Write_CText("\r\n Image 96x64\r\n");
 for (j=0;j<64;j++)
 {
  for (i=0;i<12;i++)
  {
   k=i+j*12  ;
   cx= image[k];
   masque = 0x80;
   x=0;
   while (masque > 0 )
   {
   k=i*8+x;
     if ((cx & masque)==masque)
      {
      UART1_Write('*');  //  '1'
      Nokia_Put_Pixel(k,j,1);
      }
     else
     {
      UART1_Write(' ');  //  '0'
      Nokia_Put_Pixel(k,j,0);
     }
       masque =masque /2;
       x++;
       Delay_us(20);
   }
  }
  UART1_Write(13);
  UART1_Write(10);
 }
}




void NOKIA_Chr_8x7(char xNOKIA,char yNOKIA, char charsel)
{
        char char_row,chardata;
       int charpos;   // avec une seule table de char , > 255 !!
        if(xNOKIA>0) xNOKIA-=1;
        if(yNOKIA>0) yNOKIA-=1;
        yNOKIA=yNOKIA*8;
        gotoxy(xNOKIA,yNOKIA);
        if (charsel<0x20) return;
        if (charsel>0x7f) return;
        for(char_row=0;char_row<7;char_row++)
        {
               charpos=(((charsel&0xff)-0x20)*8);
                chardata= Font_7_8[(charpos+char_row)];
                senddata(chardata);
        }
        senddata(0x00);
}


 void NOKIA_CText_8x7(char L,char  C, const char *txt)
 {
  char posX,posY ;
  posY=0;
  posX=0;
  if (L+posY>8)  return;
  while(*(txt)>0)
  {
  if ((C+posX)>12)break;
  NOKIA_Chr_8x7(L+posY,C+posX,*(txt++));
  posX++;
  }
 }



void NOKIA_Text(int x, int y, char size,unsigned char *caracter)
{
   int ind_bitmap,memory_index,xx,step;
   Byte width,Data_Caracter;
   Byte letter;
   switch(size)
   {
    case 1: width=3;break;
    case 2: width=5;break;
    case 3: width=7;break;
   }
   letter=*caracter;
   while (letter!=0)
      {
       for (xx=0;xx<width;xx++)
         if (((xx+x)<96) && ((xx+x)>=0) && (y>=0)&& (y<=56) )    // 64-8=56
          {
            memory_index = xx + x + (y>>3)*84;
            ind_bitmap = (letter-0x20) * width + xx;
            step = y%8;
            if (size==1)
                    Data_Caracter = Font_3_6[ind_bitmap];
                else
                  if (size==2)
                      Data_Caracter = Font_5_7[ind_bitmap];
                else
                 Data_Caracter = Font_7_8[ind_bitmap];
           Ram_Video[memory_index] = Ram_Video[memory_index] | (Data_Caracter<<step);
            if (step)
           Ram_Video[memory_index+96] = Ram_Video[memory_index+96] | ((Data_Caracter>>(8-step))&(0xFF >> (8-step)));
         }
       caracter++;
       letter=*caracter;
       x=x+width+1;
      }
}



// Affichage d'une ligne dans la RAM video
void Nokia_Line (char x1, char y1, char x2, char y2, char color)
{
   char DeltaX, DeltaY,MinX,MinY,MaxX,MaxY,DeltaMax,i,xx,yy;
   float OffsetX, OffsetY;
   if (y1>y2)
      {MinY=y2;MaxY=y1;OffsetY=-1;}
   else
      {MinY=y1;MaxY=y2;OffsetY=1;}
   if (y1==y2) OffsetY=0;
   if (x1>x2)
      {MinX=x2;MaxX=x1;OffsetX=-1;}
   else
      {MinX=x1;MaxX=x2;OffsetX=1;}
   if (x1==x2) OffsetX=0;
   DeltaX = MaxX-MinX+1;
   DeltaY = MaxY-MinY+1;
   if (DeltaX>DeltaY)
      {
         OffsetY = (float)DeltaY / (float)DeltaX * OffsetY;
         DeltaMax=DeltaX;
      }
   else
      {
         OffsetX = (float)DeltaX / (float)DeltaY * OffsetX;
         DeltaMax=DeltaY;
      }
   for (i=0;i<DeltaMax;i++)
      {
         xx=x1 + OffsetX * i;
         yy=y1 + OffsetY * i;
         if ((xx<96) && (yy<64) && (xx>=0) && (yy>=0))
            Nokia_Put_Pixel (xx,yy, color);
      }
}


/*
void Nokia_Bitmap_96x64 ( unsigned char * bitmap)
{
   signed int ind_bitmap,memory_index;
   signed int xx,yy,step;
   for (yy=0;yy<64;yy++)
   for (xx=0;xx<12;xx++)
               memory_index = yy * 12 + xx ;
               ind_bitmap =  yy * 12 + xx*8;
               Ram_Video[memory_index] =  bitmap[ind_bitmap];
}


void Nokia_Affiche_Ram_Video(void)
{
int ddram;
Byte x,y,s,masque;
 sendcmd(0x40);  //  Y=0 0100 0yyy
  sendcmd(0x80);  //  X =0 1xxx xxxx
    ddram=0;
   for (y=0;y<62;y++)
   {
    for (x=0;x<12;x++)
    {
      masque=0x80;
      s=0;
      while (masque>0)
      {
       ddram=(int)y *12+ (int)x *8 + s;
       if  (   (Ram_Video[ddram] & masque) > 0 )
        Nokia_Put_Pixel (x*8+s,y,1);
        else
        Nokia_Put_Pixel (x*8+s,y,0);

       s++;
       masque=masque  >>1;
      }
    }  // for x
  } // for y
}


*/
